using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;

using System.Drawing.Drawing2D;

namespace SETProject
{
    public partial class Form1 : Form
    {       
        private Rectangle[] rect;
        private int cardW = 120, cardH = 150;
        private ArrayList selCard;
        private ArrayList correctedSet;

        private ArrayList deck;

        public Form1()
        {
            InitializeComponent();

            rect = new Rectangle [12];
            selCard = new ArrayList();
            correctedSet = new ArrayList();

            deck = new ArrayList();
            
            //81 ī带 deck 
            foreach (CardShapeCategory aShape in Enum.GetValues(typeof(CardShapeCategory)))
            {
                foreach (CardColorCategory aColor in Enum.GetValues(typeof(CardColorCategory)))
                {
                    foreach (CardNumberCategory aNumber in Enum.GetValues(typeof(CardNumberCategory)))
                    {
                        foreach (CardFillCategory aFill in Enum.GetValues(typeof(CardFillCategory)))
                        {
                            deck.Add(new Card(aShape, aColor, aNumber, aFill));
                        }
                    }
                }
            }
            //deck 
            shuffleDeck();
        }

        private void shuffleDeck()
        {
            Random randomGenerator = new Random();

            int count = deck.Count;

            for (int i = count - 1; i >= 1; --i)
            {
                // Pick an random number 0 through i inclusive.
                int j = randomGenerator.Next(i + 1);

                // Swap array[i] and array[j]
                Card temp = (Card)deck[i];
                deck[i] = deck[j];
                deck[j] = temp;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            
        }

        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {

        }

        private void checkSet()
        {
            Card cardA = (Card)deck[(int)selCard[0]];
            Card cardB = (Card)deck[(int)selCard[1]];
            Card cardC = (Card)deck[(int)selCard[2]];

            bool c = false, s = false, f = false, n = false;

            // ƿ ų Ʋ ˻
            if (cardA.ColorProperty == cardB.ColorProperty && cardB.ColorProperty == cardC.ColorProperty)
                c = true;
            if (cardA.ColorProperty != cardB.ColorProperty && cardB.ColorProperty != cardC.ColorProperty && cardC.ColorProperty != cardA.ColorProperty)
                c = true;

            //
            if (cardA.ShapeProperty == cardB.ShapeProperty && cardB.ShapeProperty == cardC.ShapeProperty)
                s = true;
            if (cardA.ShapeProperty != cardB.ShapeProperty && cardB.ShapeProperty != cardC.ShapeProperty && cardC.ShapeProperty != cardA.ShapeProperty)
                s = true;

            //ä
            if (cardA.FillProperty == cardB.FillProperty && cardB.FillProperty == cardC.FillProperty)
                f = true;
            if (cardA.FillProperty != cardB.FillProperty && cardB.FillProperty != cardC.FillProperty && cardC.FillProperty != cardA.FillProperty)
                f = true;

            //
            if (cardA.NumberProperty == cardB.NumberProperty && cardB.NumberProperty == cardC.NumberProperty)
                n = true;
            if (cardA.NumberProperty != cardB.NumberProperty && cardB.NumberProperty != cardC.NumberProperty && cardC.NumberProperty != cardA.NumberProperty)
                n = true;

            if (c && s && f && n)
            {
                MessageBox.Show("SET ãҽϴ.", "Correct",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

                correctedSet.Add(cardA);
                correctedSet.Add(cardB);
                correctedSet.Add(cardC);

                deck.Remove(cardA);
                deck.Remove(cardB);
                deck.Remove(cardC);

                //ѹ ְ~
                shuffleDeck();
            }
            else
            {
                MessageBox.Show("SET ƴմϴ.", "Incorrect",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

                if (correctedSet.Count > 0)
                {
                    deck.Add(correctedSet[0]);
                    deck.Add(correctedSet[1]);
                    deck.Add(correctedSet[2]);

                    correctedSet.RemoveAt(0);
                    correctedSet.RemoveAt(0);
                    correctedSet.RemoveAt(0);
                    
                }
            }



        }

        private void Form1_MouseClick(object sender, MouseEventArgs e)
        {
            Graphics g = this.CreateGraphics();

            for (int i = 0; i < 12; i++)
            {
                int p = i;

                if (rect[i].Contains(e.X, e.Y))
                {
                    // Ÿ  
                    if (selCard.Contains(p))
                    {
                        selCard.Remove(p);
                        g.DrawRectangle(Pens.Black, rect[i]);
                        return;
                    }
                    else
                    {
                        //ƴϸ  
                        g.DrawRectangle(Pens.Pink, rect[i]);
                        selCard.Add(p);
                    }

                    
                    //3   set üũ
                    if (selCard.Count == 3)
                    {
                        checkSet();
                        selCard.Clear(); 
                        Invalidate();
                    }
                   
                }
            }
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            
            int x = 10, y = 10;
            for (int i = 0; i < 12; i++)
            {
                if (deck[i] == null)
                    MessageBox.Show("These are last cards", "Name Entry Error",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

                Card card = (Card)deck[i];

                rect[i] = new Rectangle(x, y, cardW, cardH);

                Pen color = new Pen(Color.Black);
                Brush fill;
                GraphicsPath graphPath = new GraphicsPath();
                int innerX = 0, innerY = 0;
                
                int count = 0;
                // Ӽ  (Ф ̷ 밡ٸ)
                if (card.NumberProperty == CardNumberCategory.One)
                {
                    count = 1;
                    innerX = x + (cardW * 1 / 3); 
                    innerY = y + (cardH * 1 / 3);
                }
                else if (card.NumberProperty == CardNumberCategory.Two)
                {
                    count = 2;
                    innerX = x + (cardW * 1 / 6);
                    innerY = y + (cardH * 1 / 3);
                }
                else if (card.NumberProperty == CardNumberCategory.Three)
                {
                    count = 3;
                    innerX = x + (cardW * 1 / 9);
                    innerY = y + (cardH * 1 / 3);
                }
                
                // Ӽ ŭ ׷
                for (int j = 0; j < count; j++)
                {

                    // Ӽ 
                    switch (card.ColorProperty)
                    {
                        case (CardColorCategory.Blue):
                            color.Color = Color.Blue;
                            break;
                        case (CardColorCategory.Green):
                            color.Color = Color.Green;
                            break;
                        case (CardColorCategory.Red):
                            color.Color = Color.Red;
                            break;
                        default:
                            //Console.Write("  .");
                            color.Color = Color.Black;
                            break;
                    }

                    // Ӽ 
                    switch (card.ShapeProperty)
                    {
                        case (CardShapeCategory.Ellipse):
                            graphPath.AddEllipse(innerX, innerY, 30, 50);
                            break;
                        case (CardShapeCategory.Rectangle):
                            Rectangle r = new Rectangle(innerX, innerY, 30, 50);
                            graphPath.AddRectangle(r);
                            break;
                        case (CardShapeCategory.Trapezoid):
                            Point[] p ={
                                    new Point(innerX, innerY+20),
                                    new Point(innerX+15, innerY),
                                    new Point(innerX+30, innerY+20),
                                    new Point(innerX+20, innerY+50),
                                    new Point(innerX+10, innerY+50)
                                    };

                            graphPath.AddPolygon(p);
                            break;
                    }

                    g.DrawPath(new Pen(color.Color), graphPath);

                    switch (card.FillProperty)
                    {
                        case (CardFillCategory.Full):
                            fill = new SolidBrush(color.Color);
                            e.Graphics.FillPath(fill, graphPath);
                            break;
                        case (CardFillCategory.None):
                            break;
                        case (CardFillCategory.Slash):
                            fill = new HatchBrush(HatchStyle.DottedDiamond, color.Color, Color.Empty);
                            e.Graphics.FillPath(fill, graphPath);
                            break;
                        default:
                            break;
                    }
                    innerX += 35;
                }
                
                //ī ׵θ ׷ִ κ
                if ((i + 1) % 4 == 0) { x = 10; y += 170; }
                else { x += 160; }

                g.DrawRectangle(Pens.Black, rect[i]);
            
                color.Dispose();
                graphPath.Dispose();

                //ī  display
                int a = deck.Count;
                int b = correctedSet.Count;
                this.label2.Text = a.ToString() + "";
                this.label4.Text = b.ToString() + "";
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            shuffleDeck();

            Invalidate();
        }

        private void label1_Click(object sender, EventArgs e)
        {
            
        }

        private void label2_Click(object sender, EventArgs e)
        {
            
        }

        private void label4_Click(object sender, EventArgs e)
        {

        }

        
    }
}